#include <sys/mman.h>     /* Just cut-and-pasted these from the old version */
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include "gc.h"

void setup_mem(void);

mem _top;               /* These are used to make sure we know the absolute  */
mem _bottom;            /* start/end of the memory block (just in case)      */
mem fromspace;          /* The place where objects are copied from by the GC */
mem tospace;            /* tospace is where objects are copied to/created    */
cell *free;             /* The bottom of the available free space in tospace */
cell *scanpos;          /* The address of the next cell to be scanned        */
cell *top;              /* Pointer to the top of the free space in tospace   */

char *progname;

int loops = 3;          /* Number of GC's per cons(). Higher = more, slower  */

int main(int argc, char *argv[]) {
  progname = argv[0];
  setup_mem();
  run_tests();
  return 0;
}

void setup_mem(void) {
  int fd;

  if((fd = open(MMAP_FILE, O_RDWR)) == -1) {
    perror(progname);
    exit(-1);
  }
  if((_bottom = mmap((caddr_t) 0, MMAP_LEN, PROT_READ|PROT_WRITE,
		     MAP_SHARED|MAP_FILE, fd, 0)) == (caddr_t) -1) {
    perror(progname);
    exit(-1);
  }
  /*
  _top      = _bottom + MMAP_LEN;*/
  _top      = _bottom + 48;
  tospace   = _bottom;
  free      = tospace;
  /*  fromspace = _bottom + SPACE_SIZE;*/
  fromspace = _bottom + (_top-_bottom)/2;
  top       = fromspace;
  scanpos   = tospace;
}
