/*
 * MMAP_LEN is the size of MMAP_FILE. MMAP_FILE is the path to the filename
 * to mmap(). It's odd that I named mine persistent-tunes even when it's
 * not persistent yet. Well, I'm working on it. :)
 */

#define PAGE 4096
#define MMAP_FILE "/usr/local/etc/persistent-tunes"
#define MMAP_LEN (PAGE*(10<<10))
#define SPACE_SIZE (MMAP_LEN/2)
#define NIL NULL

typedef void *mem;

typedef struct cell {
  mem car;
  struct cell *cdr;
} cell;

extern mem _top;        /* These are used to make sure we know the absolute  */
extern mem _bottom;     /* start/end of the memory block (just in case)      */
extern mem fromspace;   /* The place where objects are copied from by the GC */
extern mem tospace;     /* tospace is where objects are copied to/created    */
extern cell *free;      /* The bottom of the available free space in tospace */
extern cell *scanpos;   /* The address of the next cell to be scanned        */
extern cell *top;       /* The next free cell at the top of tospace          */

extern int loops;       /* Number of GC's per cons(). Higher = more, slower  */

extern char *progname;  /* naaasty */

/* from gc.c */
void dump_ptrs(void);
void error(char *error);

/* lists.c */
cell *cons(mem car, cell *cdr);
void flip(void);
mem move(cell *p);
mem copy(cell *p);
int in_tospace(mem p);
int in_fromspace(mem p);

/* in test.c */
void run_tests(void);

#define CAR(x)        (printf("car\n"),x->car = move(x->car))
#define CDR(x)        (printf("cdr\n"),x->cdr = move(x->cdr))
#define REPLACA(x, y) (x->car = y)
#define REPLACD(x, y) (x->cdr = y)
#define EQ(x, y)      (x == y)
#define ATOM(x)       (!in_tospace(x))
