#include <stdio.h>
#include "gc.h"

cell *cons(mem car, cell *cdr) {     /* Allocate a list cell */
  int i;

  if(free == top) {
    if(scanpos < free) error("Out of memory?\n");
    flip();
    car = move(car);
    cdr = move(cdr);
  }
  for(i = 0; i < loops && scanpos < free; i++) {
    printf("if(%p != NIL) scanpos->car = move(scanpos->car);\n", scanpos->car);
    if(scanpos->car != NIL) scanpos->car = move(scanpos->car);
    printf("if(%p != NIL) scanpos->cdr = move(scanpos->cdr);\n", scanpos->cdr);
    if(scanpos->cdr != NIL) scanpos->cdr = move(scanpos->cdr);
    scanpos++;
  }
  if(free == top) error("Out of memory again?");
  top--;
  top->car = car;
  top->cdr = cdr;
  return top;
}

void flip(void) {           /* flip the semispaces */
  free      = fromspace;
  fromspace = tospace;
  tospace   = free;
  free      = tospace;
  scanpos   = tospace;
  top       = tospace+(_top-_bottom)/2;
}

mem move(cell *p) {   /* Move a cell from fromspace to tospace, if need be */
  printf("move(%p);\n", p);
  if(!in_fromspace(p)) return p;
  printf("FREAKY!\n");
  if(p == NIL) return p->car;
  printf("hmm...\n");
  if(!in_tospace(p->car)) p->car = copy(p);  /* p is a list, copy it! */
  printf("p->car = %p\n", p->car);
  return p->car;
}

mem copy(cell *p) {
  printf("copy(%p)\n", p);
  if(free >= top) error("Out of memory, apparently\n");
  free->car = p->car;
  free->cdr = p->cdr;
  return free++;
}

int in_tospace(mem p) {
  printf("in_tospace(%p);\n", p);
  if(p >= tospace) {
    if(tospace > fromspace && p < _top) return 1;
    if(tospace < fromspace && p < fromspace) return 1;
  }
  printf("nope\n");
  return 0;
}

int in_fromspace(mem p) {
  printf("in_fromspace(%p);\n", p);
  if(p >= fromspace) {
    if(fromspace > tospace && p < _top) return 1;
    if(fromspace < tospace && p < tospace) return 1;
  }
  printf("nope\n");
  return 0;
}
